uniform sampler2D tex;

varying vec3 vpos, norm, ldir;
varying vec2 mask_tc;

void main()
{
	vec3 texel = texture2D(tex, gl_TexCoord[0].st).xyz;
	float mask = texture2D(tex, mask_tc).a;

	vec3 v = -normalize(vpos);
	vec3 n = normalize(norm);
	vec3 l = normalize(ldir);
	vec3 h = normalize(v + l);

	vec3 dcol = max(dot(n, l), 0.0) * vec3(1.0, 1.0, 1.0);
	vec3 scol = pow(max(dot(n, h), 0.0), 60.0) * vec3(0.6, 0.6, 0.6);

	gl_FragColor.xyz = (vec3(0.05, 0.05, 0.05) + dcol) * texel + scol;
	gl_FragColor.a = mask;
}
