#ifndef MATERIAL_H_
#define MATERIAL_H_

#include <vmath/vmath.h>
#include "texture.h"

enum {
	TEX_DIFFUSE,
	TEX_NORMAL,

	MAX_MTL_TEXTURES
};

class Material {
public:
	Vector3 diffuse, specular;
	float alpha;
	float shininess;

	Texture *tex[MAX_MTL_TEXTURES];

	Vector2 tex_scale;

	Material();

	void bind(bool use_tex = true) const;
};

#endif	// MATERIAL_H_
