#ifdef WIN32
#include <windows.h>
#endif
#ifndef __APPLE__
#include <GL/gl.h>
#else
#include <OpenGL/gl.h>
#endif
#include <imago2.h>

#include "texture.h"

Texture::Texture()
{
	id = 0;
}

Texture::~Texture()
{
	if(id) {
		glDeleteTextures(1, &id);
	}
}

bool Texture::load(const char *fname)
{
	if(!(id = img_gltexture_load(fname))) {
		return false;
	}
	return true;
}

unsigned int Texture::get_id() const
{
	return id;
}

void Texture::bind(int texunit) const
{
	if(!id) return;

	if(texunit) {
		glActiveTexture(GL_TEXTURE0 + texunit);
	}
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, id);
	if(texunit) {
		glActiveTexture(GL_TEXTURE0);
	}
}

void bind_texture(Texture *tex, int tex_unit)
{
	if(tex) {
		tex->bind(tex_unit);
	} else {
		glActiveTexture(GL_TEXTURE0 + tex_unit);
		glDisable(GL_TEXTURE_2D);
	}
}
